import spidev
from RPi import GPIO
import time

class Frs400:
    def __init__(self,channel,bus=0,device=0):
        self.channel = channel
        self._bus = bus
        self._device = device



    def readValue(self):
        self.spi = spidev.SpiDev()
        self.spi.open(self._bus,self._device)
        self.spi.max_speed_hz = 100

        # lange versie van bitoperaties
        # commandbyte1 = 1  # 0b00000001
        # # commandbyte2 = 0x80  # 0b10000000
        # commandbyte2 =(0b1000 | self.channel)<<4
        # commandbyte3 = 0  # 0b00000000
        # listCommandBytes = [commandbyte1, commandbyte2, commandbyte3]
        # # comandbyte = (commandbyte1<<16)| (commandbyte2<<8) |commandbyte1
        #
        # bytes_in = self.spi.xfer2(listCommandBytes)
        # # print(bytes_in)
        #
        # firstbits = (bytes_in[1] & 0b00000011) << 8
        # tenbit = firstbits | bytes_in[2]
        # self.freeOrNot(self.valueToVolt(tenbit))


        #korte versie van bitoperaties

        bits=self.spi.xfer2([1,(8+self.channel)<<4,0])
        data = ((bits[1]&3 << 8)+bits[2])
        # print(data)
        # self.freeOrNot(self.valueToVolt(data))
        status = self.freeOrNot(self.valueToVolt(data))

        self.spi.close()
        return status


    def freeOrNot(self,volt):
        if volt < 0.1:
            # print("stoel {0} is vrij".format(self.channel+1))
            return 0
        else:
            # print("stoel {0} is bezet".format(self.channel+1))
            return 1


    @staticmethod
    def valueToVolt(value):
        volt = value *3.3 /1023
        # print(volt)
        return volt






