from RPi import GPIO
import time

class Lcd:
    def __init__(self,rs,e,d0,d1,d2,d3,d4,d5,d6,d7):
        self.rs= rs
        self.e=e
        self.d0=d0
        self.d1=d1
        self.d2=d2
        self.d3=d3
        self.d4=d4
        self.d5=d5
        self.d6=d6
        self.d7 = d7

        self.pin=[self.rs, self.e]
        self.list_GPIO=[self.d0, self.d1,self.d2,self.d3,self.d4,self.d5,self.d6,self.d7]

        GPIO.setmode(GPIO.BCM)

        for i in self.list_GPIO:
            GPIO.setup(i,GPIO.OUT)
        for i in self.pin:
            GPIO.setup(i, GPIO.OUT)

        self.schrijf(0b111111,0)
        self.schrijf(0b1110,0)
        self.schrijf(1,0)


    def off(self):
        self.schrijf(0b1000,0)

    def schrijf(self,byte,soort=1):
        GPIO.output(self.e, GPIO.HIGH)
        if (soort == 1):
            GPIO.output(self.rs, GPIO.HIGH)
        else:
            GPIO.output(self.rs, GPIO.LOW)
        for i in range(0, 8, 1):
            if ((byte & (2 ** i)) == 0):
                bit = self.list_GPIO[i]
                GPIO.output(bit, 0)
            else:
                bit = self.list_GPIO[i]
                GPIO.output(bit, 1)
        time.sleep(0.002)
        GPIO.output(self.e, GPIO.LOW)

    def go_to_second_row(self):
        self.schrijf(self.changePlace(40), 0)

    def schrijf_een_regel(self,lijst):
        for i in lijst:
            self.schrijf(i,1)

    def schrijf_twee_regels(self,regel1,regel2):
        self.schrijf(1,0)
        lijst1 = self.vertaal_zin(str(regel1))
        lijst2= self.vertaal_zin(str(regel2))
        # print(lijst1)
        # print(lijst2)
        for i in lijst1:
            self.schrijf(i,1)

        self.go_to_second_row()

        for i in lijst2:
            if i != 32:
                self.schrijf(i,1)

    def changePlace(self,place):
        self.place = place + 128
        return self.place

    @staticmethod
    def vertaal_zin(zin):
        lijst = list(zin)
        # print(lijst)
        accii=[]
        for i in lijst:
            letter = ord(i)
            accii.append(letter)
        return accii



