from RPi import GPIO
import time

class Rgb:
    def __init__(self, rood, groen, blauw, ground):
        self.rood = rood
        self.groen = groen
        self.blauw = blauw
        self.ground  = ground

        GPIO.setmode(GPIO.BCM)

        GPIO.setup(self.rood, GPIO.OUT)
        GPIO.setup(self.groen, GPIO.OUT)
        GPIO.setup(self.blauw, GPIO.OUT)
        GPIO.setup(self.ground, GPIO.OUT)

        GPIO.output(self.ground, GPIO.HIGH)

    #     pwm-signaal definieren
        self.roodPWM = GPIO.PWM(self.rood,1000)
        self.groenPWM = GPIO.PWM(self.groen, 1000)
        self.blauwPWM = GPIO.PWM(self.blauw, 1000)


    def kleuren(self, r, g, b):
        self.roodPWM.start(0)
        self.groenPWM.start(0)
        self.blauwPWM.start(0)
        GPIO.output(self.ground, GPIO.LOW)

        self.roodPWM.ChangeDutyCycle(self.valueToColor(r))
        self.groenPWM.ChangeDutyCycle(self.valueToColor(g))
        self.blauwPWM.ChangeDutyCycle(self.valueToColor(b))

        time.sleep(4)

        self.roodPWM.stop()
        self.groenPWM.stop()
        self.blauwPWM.stop()
        GPIO.output(self.ground,GPIO.HIGH)


    @staticmethod
    def valueToColor(value):
        color= value/255*100
        print(round(color))
        return round(color)


class RgbLeds:
    def __init__(self,DS,OE,STCP,SHCP,MR):
        self.DS = DS  # serial data
        self.OE = OE  # output enable (active low)
        self.STCP = STCP  # storage register clock pulse
        self.SHCP = SHCP  # shift register clock pulse
        self.MR = MR

        self.delay = (1/ 1e7)/2

        GPIO.setmode(GPIO.BCM)
        GPIO.setwarnings(False)

        segmenten = [self.DS,self.OE,self.STCP,self.SHCP,self.MR]

        for item in segmenten:
            GPIO.setup(item, GPIO.OUT)
            GPIO.output(item, GPIO.LOW)

        GPIO.output(self.MR, GPIO.HIGH)



    def write_bit(self,value):
        GPIO.output(self.DS, value)
        GPIO.output(self.SHCP, GPIO.HIGH)
        time.sleep(self.delay)
        GPIO.output(self.SHCP, GPIO.LOW)
        time.sleep(self.delay)


    def clokbit(self):
        GPIO.output(self.STCP, GPIO.HIGH)
        time.sleep(self.delay)
        GPIO. output(self.STCP, GPIO.LOW)
        time.sleep(self.delay)



    def write_byte(self,value):
        for item in range(7,-1,-1):
            #  de and gewoon schrijven lukt niet!!
            bit =value & (1<<item)
            # print(bit)
            if bit==0:
                self.write_bit(0)
            else:
                self.write_bit(1)

        self.clokbit()


    def kleuren(self,led1=False,led2=False,led3=False,led4=False):
        rood1 =1<<0
        groen1=1<<1
        rood2=1<<3
        groen2=1<<2
        rood3=1<<5
        groen3=1<<4
        rood4=1<<7
        groen4=1<<6

        byte = 0
        if led1 ==False:
            byte =byte |groen1
        else:
            byte = byte|rood1

        if led2 ==False:
            byte =byte |groen2
        else:
            byte = byte|rood2

        if led3 ==False:
            byte =byte |groen3
        else:
            byte = byte|rood3

        if led4  ==False:
            byte =byte |groen4
        else:
            byte = byte|rood4

        self.write_byte(byte)



    def off(self):
        self.write_byte(0)