from RPi import GPIO
from sensor.models.Frs400 import Frs400
from sensor.models.display import Lcd
from sensor.models.rgbLed import RgbLeds as Rgb
from  threading import Thread
import time
import socket
import mysql.connector



hostname = 'localhost'
database = 'project1'
password = 'stephanie123123'
username = 'project1-sensor'



def getipaddress():
    s= socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    s.connect(("8.8.8.8",80))
    ipAdress= s.getsockname()[0]
    return ipAdress

def writeToDBStart(data):
    conn = mysql.connector.connect(host=hostname, user=username,password=password, database=database)
    cur = conn.cursor()
    # print("INSERT INTO bezetting(stoelId, statusid, serienummerwagon, tijdBegin,stoelnr) VALUES (%s,%s,%s,%s,%s)",(data))
    cur.execute("INSERT INTO bezetting(statusid, serienummerwagon, tijdBegin,stoelnr) VALUES (%s,%s,now(),%s)",(data))
    conn.commit()
    cur.close()
    conn.close()

def writeToDBEnd(stoelid):
    conn = mysql.connector.connect(host=hostname, user=username,password=password, database=database)
    cur = conn.cursor()
    cur.execute(" update bezetting set tijdEinde=now() where stoelId = %s",(stoelid,))
    conn.commit()

    cur.close()
    conn.close()

def get_data(stoelnr):
    # print(stoelnr)
    conn = mysql.connector.connect(host=hostname, user=username,password=password, database=database)  # connectie maken met de database
    cursor = conn.cursor()  # je heb bij het uithalen van gegevens ook een cursor
    try:
        cursor.execute("select stoelId from bezetting where tijdEinde is NULL and stoelnr = %s ", (stoelnr,))
    except Exception as e:
        # print(e)
        return False

    results = cursor.fetchall()
    cursor.close()
    conn.close()
    return results


def main():
    GPIO.setmode(GPIO.BCM)

    # inisatlisatie van alle componenten
    # bezet = 0 vrij=1
    stoel1 = Frs400(0)
    stoel2 = Frs400(2)
    stoel3 = Frs400(4)
    stoel4=Frs400(6)

    # rs,e,d0,d1,d2,d3,d4,d5,d6,d7
    display = Lcd(16,12,20,21,22,27,25,24,23,18)

    # DS,OE,STCP,SHCP,MR
    # false geeft rood
    led=Rgb(5,6,13,19,26)

    # specificaties van de trein, specifieke wagon
    serienummerWagon = "15800268561"


    # lijst met bezzette stoelen id
    bezet=[]

    #  effectieve programma
    try:
        ip =getipaddress()
        display.schrijf_twee_regels("het ip-adres:",ip)
        time.sleep(4)
        while True:
            led.kleuren(False, False, False, False)

            s1 = stoel1.readValue()
            # print("s1 {}".format(s1))
            s2 = stoel2.readValue()
            # print("s2 {}".format(s2))
            s3= stoel3.readValue()
            # print("s3 {}".format(s3))
            s4=stoel4.readValue()
            # print("s4 {}".format(s4))

            # stoelen = [s1,s2,s3,s4]
            # aantal = 0
            # stoelnr = 0
            # # print(bezet)
            # for i in stoelen:
            #     # print("lijst bezet {}".format(bezet))
            #     stoelnr+=1
            #     if i == False:
            #         # vrije plaats
            #         aantal += 1
            #         if len(bezet) != 0:
            #             stoelid = get_data(stoelnr)
            #             # print(bezet)
            #             # print(stoelnr)
            #             # print("stoelid vrij {}".format(stoelid))
            #             if len(stoelid) != 0:
            #                 stoelid = stoelid[0][0]
            #                 if stoelid in bezet:
            #                     # print(stoelid)
            #                     print("ik raak in het einde")
            #                     # stoelId= %s and serienummerwagon= %s and stoelnr = %s and tijdBegin = %S
            #                     writeToDBEnd((stoelid))
            #                     bezet.remove(stoelid)
            #
            #
            #     else:
            #         stoelid = get_data(stoelnr)
            #         print(stoelid)
            #         if len(stoelid) == 0:
            #                 print("jaa")
            #                 writeToDBStart((0, serienummerWagon, stoelnr))
            #                 stoelid = get_data(stoelnr)
            #                 print("stoelid {}".format(stoelid))
            #                 if len(stoelid) != 0:
            #                     # print("ik append stoelid")
            #                     bezet.append(stoelid[0][0])
            #                     # print("stoelid {0}".format(stoelid[0][0]))
            #
            #
            # print(aantal)
            # display.schrijf_twee_regels("vrije plaatsen", aantal)
            # time.sleep(2)
            #
            # led.kleuren(s2,s1,s4,s3)
            # display.schrijf_twee_regels("het ip-adres:", ip)
            time.sleep(2)


    except KeyboardInterrupt:
        pass
    finally:
        # leds terug uitzetten
        led.off()
        display.off()
        GPIO.cleanup()


# Deze vreemde constructie zorgt ervoor dat de functie main enkel wordt opgeroepen
# wanneer het script rechtstreeks wordt gestart.
if __name__ == '__main__':
    main()
