from flask import Flask,request,make_response,url_for,abort
from flask import render_template,redirect
from flaskext.mysql import MySQL



app = Flask(__name__)


#connectie maken met je database
mysql = MySQL(app)
app.config["MYSQL_DATABASE_HOST"]= "localhost"
app.config["MYSQL_DATABASE_DB"]= "project1"
app.config["MYSQL_DATABASE_USER"]= "project1-web"
app.config["MYSQL_DATABASE_PASSWORD"]= "stephanie123123"

def get_data(sql,parameters=None):
    conn = mysql.connect()  # connectie maken met de database
    cursor = conn.cursor()  # je heb bij het uithalen van gegevens ook een cursor

    try:
        cursor.execute(sql, parameters)
    except Exception as e:
        print(e)
        return False

    results = cursor.fetchall()  # alle date nemen
    db_data = []
    for row in results:
        db_data.append(list(row))
    # print(db_data)

    cursor.close()
    conn.close()
    return db_data

def get_one(sql,parameters=None):
    conn = mysql.connect()  # connectie maken met de database
    cursor = conn.cursor()  # je heb bij het uithalen van gegevens ook een cursor

    try:
        cursor.execute(sql, parameters)
    except Exception as e:
        # print(e)
        return False

    results = cursor.fetchone()
    cursor.close()
    conn.close()
    return results

def set_data(sql,parameters=None):
    conn = mysql.connect()
    cur = conn.cursor()

    cur.execute(sql,parameters)
    conn.commit()
    cur.close()
    conn.close()

# errorpagina's
@app.errorhandler(404)
def page_not_found(e):
    return render_template("trainNotFount.html"),404



@app.route('/')
def index():

    return render_template("index.html")

@app.route('/statestiek')
def statestiek():
    aantalReizigers=get_data("select hour(b.tijdBegin), count(b.statusid) as `aantal` from bezetting as b left join wagon as  w on b.serienummerwagon=w.serienummer where b.statusid=0 and convert(DATE_FORMAT(tijdBegin, '%Y,%m,%d'),date) = convert(DATE_FORMAT(now(), '%Y,%m,%d'),date) group by hour(b.tijdBegin)")
    list=[]
    for i in range (0,25):
        list.append(0)
    for item in aantalReizigers:
        list[item[0]]=item[1]
    for i in range(0,4):
        list.pop(i)
    print(list)
    dic={}
    for i in range(0,25):
        dic[i]=0
    for item in aantalReizigers:
        dic[item[0]]=item[1]

    gemiddeldeZittijd=get_data("select SEC_TO_TIME( round(AVG ( TIMESTAMPDIFF ( SECOND, b.tijdBegin,b.tijdEinde)),0)) as `gemiddelde` from bezetting as b  left join wagon as w on b.serienummerwagon=w.serienummer;")
    gemiddeldeVertraging=get_data("select  sec_to_time(round(AVG(TIMESTAMPDIFF (second, datetimeGepland,datetimeReal)),0)) from traject")
    aantalReizigersHuidig=get_data("select count(stoelid) from bezetting where statusid=0 and tijdEinde is null")

    return render_template("statestiek.html",dic=list,gemiddeldeZittijd=gemiddeldeZittijd,vertraging=gemiddeldeVertraging,huidigeReizigers=aantalReizigersHuidig)

@app.route('/home', methods=['GET', 'POST'])
def home():
    data = get_data("select naam from halte")
    lijst=[]
    for item in data:
        lijst.append(item[0])
    print(lijst)
    if request.method == "POST":
        van = request.form['van']
        naar = request.form['naar']
        datum =request.form['date']
        tijd = request.form['tijd']
        datum = str(datum +" "+ tijd+":00")
        # print(datum)
        return redirect(url_for('treinen', van=van, naar=naar,tijd=datum))
    else:
        return render_template("home.html", data=lijst)




@app.route('/wagon/<van>/<naar>/<tijd>/<wagonnr>')
def wagon(van,naar,tijd,wagonnr):
    treinnr = get_one("select t.treinNr from halte as h join traject as t on h.id=t.halteid join trein as tr on t.treinNr = tr.treinNr where t.treinNr in (select tr2.treinNr from halte as h2 join traject as t2 on h2.id=t2.halteid join trein as tr2 on t2.treinNr = tr2.treinNr where h2.naam = (%s) and t2.datetimeGepland between (%s) and (%s) +interval 40 minute and t.datetimeGepland > t2.datetimeGepland) and h.naam=(%s)",(van,tijd,tijd,naar))
    capasiteit= get_data("select w.capaciteit from wagon as w where w.treinId=(%s) and w.volgordeNummer=(%s) order by w.volgordeNummer asc;", (treinnr,wagonnr))
    klasse = get_one("select klasse from wagon where treinid=(%s) and volgordeNummer =(%s)",(treinnr,wagonnr))
    bezetting=get_data("select stoelnr from bezetting as b left join wagon as w on w.serienummer=b.serienummerwagon where w.treinId =(%s) and w.volgordeNummer=(%s) tijdEinde is null",(treinnr,wagonnr))
    bezettestoelen=[]
    print(bezetting)
    if bezetting == False:
        bezettestoelen=[]
    else:
        for item in bezetting:
            bezettestoelen.append(item[0])
    # bezettestoelen = [1,13,14,15,16,17,3,11,10]
    stoelenPerRij=0
    for item in capasiteit[0]:
        stoelenPerRij=int(item/4)
    aantalWagons=get_one("select count(*) from wagon as w left join trein as t on w.treinId=t.treinNr where w.treinId in(%s)",treinnr)

    return render_template("wagon.html", aantalWagons=aantalWagons[0], capasiteit=stoelenPerRij, wagonnr=wagonnr, klasse= klasse, bezette=bezettestoelen, van=van, naar=naar, tijd=tijd)

@app.route('/treinen/<van>/<naar>/<tijd>')
def treinen(van,naar,tijd):

    treinnummers = get_data("select tr.treinNr from halte as h join traject as t on h.id=t.halteid  join trein as tr on t.treinNr = tr.treinNr  where tr.treinNr in (select tr.treinNr  from halte as h join traject as t on h.id=t.halteid join trein as tr on t.treinNr = tr.treinNr  where h.naam = (%s) and t.datetimeGepland between (%s) and (%s) + interval 60 minute) and h.naam=(%s)",(van,tijd,tijd,naar))
    print(len(treinnummers))
    if len(treinnummers)== 0:
        abort(404)
    else:
        treinen = get_data("select t.datetimeGepland,ty.omschrijving from halte as h join traject as t on h.id=t.halteid join trein as tr on t.treinNr = tr.treinNr join type as ty on ty.typenaam=tr.typenaam where tr.treinNr in(%s) and h.naam=(%s) and t.datetimeGepland between (%s) and (%s)+interval 30 minute ",(treinnummers,van,tijd,tijd))
        print(treinen[0][1])
        accomodatie=treinen[0][1].split(",")


        bezetting = get_data("select count(*) from wagon as w left join bezetting as b on b.serienummerwagon= w.serienummer where w.treinId in (%s) and b.statusid=0 and tijdEinde is null; ",treinnummers)
        bezetting_trein=[]
        for item in bezetting:
            bezetting_trein.append(item[0])
        return render_template("treinen.html", van=van, naar=naar, tijd=tijd, data= treinen,accomodatie=accomodatie, bezetting=bezetting_trein, treinnummers=treinnummers)

if __name__ == '__main__':
    app.run(debug=True,host='0.0.0.0',port=5000)
